# Contributing

Contributions are welcome! Please first discuss the change you wish to make via issue or email before making a change. It's a small focused library, dive in.

## GitHub Mirror

The project is mirrored to GitHub, but all development is done on GitLab. Please use the [GitLab issue tracker](https://gitlab.com/starshell/question/issues). Want to open an issue but don't have a GitLab account? Just email `incoming+starshell/question@gitlab.com` and those emails automatically become issues (with the comments becoming the email conversation).

## Roadmap to Stable
- [ ] Document public interface
- [ ] General bug hunting
- [ ] Refine public interface
- [ ] More examples
- [ ] Extend dependency injection to allow for testing of multiple user inputs
- [ ] Allow for entry of custom valid answers (especially to support other languages)
- [ ] Compliance with the [Rust API Guidelines](https://rust-lang-nursery.github.io/api-guidelines/)

## Wants
- [ ] Specify a return type or provide a parser
- [ ] Properly handle secrets
